image: node:18

stages:
    - lint
    - test
    - publish
    - docs

cache:
    paths:
        - node_modules/

before_script:
    - npm install
    - npm run build

eslint:
    stage: lint
    script:
        - npm run lint

spellcheck:
    stage: lint
    script:
        - npm run spellcheck

test_lib:
    stage: test
    script:
        - npm run test

pages:
    stage: docs
    script:
        - npm run docs
    artifacts:
        paths:
            - public
    only:
        - master

development:
    stage: publish
    before_script:
        # add "-development.XXXX" at the end of the version in the package file during this script
        - sed -i -r "/version/s/([0-9\.]+)/\1-development.${CI_JOB_ID}/g" package.json
    script:
        - npm config set //registry.npmjs.org/:_authToken ${NPM_AUTH_TOKEN}
        - npm publish --tag development
    only:
        - master

